const config = require('../../config');
const providers = config.providers;
const crypto = require('crypto');
const bcrypt = require('bcrypt');
const moment = require('moment');

module.exports = function(sequelize, DataTypes) {
  const production_orders = sequelize.define(
    'production_orders',
    {
      id: {
        type: DataTypes.UUID,
        defaultValue: DataTypes.UUIDV4,
        primaryKey: true,
      },

order_number: {
        type: DataTypes.TEXT,
      
      

      },

status: {
        type: DataTypes.ENUM,
      
      

        values: [

"planned",


"released",


"in_progress",


"paused",


"completed",


"canceled"

        ],

      },

planned_start_at: {
        type: DataTypes.DATE,
      
      

      },

planned_end_at: {
        type: DataTypes.DATE,
      
      

      },

actual_start_at: {
        type: DataTypes.DATE,
      
      

      },

actual_end_at: {
        type: DataTypes.DATE,
      
      

      },

notes: {
        type: DataTypes.TEXT,
      
      

      },

      importHash: {
        type: DataTypes.STRING(255),
        allowNull: true,
        unique: true,
      },
    },
    {
      timestamps: true,
      paranoid: true,
      freezeTableName: true,
    },
  );

  production_orders.associate = (db) => {


/// loop through entities and it's fields, and if ref === current e[name] and create relation has many on parent entity


















    db.production_orders.hasMany(db.production_operations, {
      as: 'production_operations_production_order',
      foreignKey: {
          name: 'production_orderId',
      },
      constraints: false,
    });


    db.production_orders.hasMany(db.quality_inspections, {
      as: 'quality_inspections_production_order',
      foreignKey: {
          name: 'production_orderId',
      },
      constraints: false,
    });











//end loop



    db.production_orders.belongsTo(db.users, {
      as: 'owner',
      foreignKey: {
        name: 'ownerId',
      },
      constraints: false,
    });

    db.production_orders.belongsTo(db.deals, {
      as: 'deal',
      foreignKey: {
        name: 'dealId',
      },
      constraints: false,
    });

    db.production_orders.belongsTo(db.organizations, {
      as: 'organizations',
      foreignKey: {
        name: 'organizationsId',
      },
      constraints: false,
    });




    db.production_orders.belongsTo(db.users, {
      as: 'createdBy',
    });

    db.production_orders.belongsTo(db.users, {
      as: 'updatedBy',
    });
  };



  return production_orders;
};


